/*
    Copyright (C) 2002, Steve Lhomme <steve.lhomme @ free.fr>
    This file is part of ac32wav.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**
    \file
*/

#ifndef _M2W_AC3_WAV_H_
#define _M2W_AC3_WAV_H_

#include "wav.h"
#include "ac3_format.h"
#include "ac3frame.h"

START_M2W_NAMESPACE

class AC3_WAV_file : public WAV_file {
    public:
	AC3_WAV_file(const std::string & aFileName)
	    :WAV_file(aFileName)
	{}

	~AC3_WAV_file()
	{}

	inline FORMAT_chunk & FormatEx() {return *static_cast<FORMAT_chunk *>(&myFormat);}

	void setSampleSize(const uint16 size) {myFormat.setSampleSize(size);}
	virtual void WriteHead(const uint32 data_size, const uint32 sample_number, bool seek_to_start);

	uint16 SamplingRate() const {return myFormat.SamplingRate(); }

	void setFrameType(const AC3_Frame & aFrame);

    protected:
	AC3_FORMAT_chunk myFormat;
};

END_M2W_NAMESPACE

#endif // _M2W_AC3_WAV_H_
